local audioErrCnt = GetAudioErrorCount()
local avgAudioLevel = 0

function UpdateAvgAudioLevel()	-- part of the VAD
	local signalLevel = GetAudioRxSignalLevel()
	local coeff = 0.95
	avgAudioLevel = avgAudioLevel * coeff + signalLevel * (1-coeff)
end

function WaitForEndOfWavFile()
	while true do
		local cb = CheckBreak();
		if cb ~= 0 then
			print ('User break\n')
			return false
		end
		local callState = GetCallState()
		if callState == 0 then
			return false
		end
		local errCnt = GetAudioErrorCount()
		-- print(string.format("WaitForEndOfWavFile: errCnt = %u\n", errCnt))
		if errCnt ~= audioErrCnt then
			audioErrCnt = errCnt
			return true;
		end
		UpdateAvgAudioLevel()
		Sleep(50)
	end
end

function WaitForVoice()
	local i
	local levelCnt = 0
	for i=1, 500, 1 do
		local cb = CheckBreak();
		if cb ~= 0 then
			print ('User break\n')
			return false
		end
		local callState = GetCallState()
		if callState == 0 then
			return false
		end
		local signalLevel = GetAudioRxSignalLevel()
		-- print(string.format("WaitForVoice: signalLevel = %d, levelCnt = %d\n", signalLevel, levelCnt))
		if signalLevel > 500 then
			if signalLevel > 4000 or signalLevel > avgAudioLevel * 5 or avgAudioLevel > signalLevel * 5 then
				levelCnt = levelCnt + 1
				if levelCnt > 20 then
					return true
				end
			end
		end
		UpdateAvgAudioLevel()
		Sleep(50)
	end
	return false
end

function WaitForSilence()
	local i
	local levelCnt = 0
	for i=1, 2000, 1 do
		local cb = CheckBreak();
		if cb ~= 0 then
			print ('User break\n')
			return false
		end
		local callState = GetCallState()
		if callState == 0 then
			return false
		end
		local signalLevel = GetAudioRxSignalLevel()
		-- print(string.format("WaitForSilence: signalLevel = %d, levelCnt = %d\n", signalLevel, levelCnt))
		if signalLevel < 500 or (signalLevel < 3000 and signalLevel < avgAudioLevel * 1.25 and avgAudioLevel < signalLevel * 1.25) then
			levelCnt = levelCnt + 1
			if levelCnt > 30 then
				return true
			end
		else
			levelCnt = 0
		end
		UpdateAvgAudioLevel()
		Sleep(50)
	end
	return false
end

local jsonString = [[
{
   "Calls" : {
      "DisconnectCallOnAudioError" : false
   }
}
]]
UpdateSettings(jsonString)	-- making sure call would not be disconnected at the end of wav file

print("Lenny: anwering...\n")
Answer()

SwitchAudioSource("nullaudio", "")
Sleep(1500)

callState = GetCallState()
if callState ~= 6 then -- ESTABLISHED
	print(string.format("Lenny: Unexpected: callState = %d\n", callState))
	Hangup()
	return
end

--[[
-- single-cycle, disconnecting after last announcement; use "---" above to enable, "--" to disable code block
for i=1, 15 do
	local name = string.format("Lenny%d.wav", i)
	SwitchAudioSource("aufile", name)
	WaitForEndOfWavFile()
	WaitForVoice();
	WaitForSilence();
	local cb = CheckBreak();
	if cb ~= 0 then
		print ('User break\n')
		Hangup()
		return
	end
end

SwitchAudioSource("aufile", "Lenny16-rickroll.wav")
WaitForEndOfWavFile()

Hangup()
--]]


---[[
-- looped 10 times; use "---" above to enable, "--" to disable code block
local name = string.format("Lenny1.wav")
SwitchAudioSource("aufile", name)
WaitForEndOfWavFile()
WaitForVoice();
WaitForSilence();

for j=1, 10 do
	for i=2, 16 do
		local name = string.format("Lenny%d.wav", i)
		SwitchAudioSource("aufile", name)
		WaitForEndOfWavFile()
		WaitForVoice();
		WaitForSilence();
		local cb = CheckBreak();
		if cb ~= 0 then
			break
		end
	end
	local cb = CheckBreak();
	if cb ~= 0 then
		print ('User break\n')
		break
	end
	callState = GetCallState()
	if callState ~= 6 then -- ESTABLISHED
		print("Lenny: end of call\n")
		break
	end
end
Hangup()
--]]
